diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netplex/netplex_config.ml ocamlnet-4.1.9.patched/src/netplex/netplex_config.ml
--- src/netplex/netplex_config.ml	2021-03-24 16:20:15
+++ src/netplex/netplex_config.ml	2026-05-29 06:31:44
@@ -1,5 +1,195 @@
 (* $Id$ *)
 
+module Stream = Netstring_stream
+module Genlex = struct
+type token =
+    Kwd of string
+  | Ident of string
+  | Int of int
+  | Float of float
+  | String of string
+  | Char of char
+
+(* The string buffering machinery *)
+
+let initial_buffer = Bytes.create 32
+
+let buffer = ref initial_buffer
+let bufpos = ref 0
+
+let reset_buffer () = buffer := initial_buffer; bufpos := 0
+
+let store c =
+  if !bufpos >= Bytes.length !buffer then begin
+    let newbuffer = Bytes.create (2 * !bufpos) in
+    Bytes.blit !buffer 0 newbuffer 0 !bufpos;
+    buffer := newbuffer
+  end;
+  Bytes.set !buffer !bufpos c;
+  incr bufpos
+
+let get_string () =
+  let s = Bytes.sub_string !buffer 0 !bufpos in buffer := initial_buffer; s
+
+(* The lexer *)
+
+let make_lexer keywords =
+  let kwd_table = Hashtbl.create 17 in
+  List.iter (fun s -> Hashtbl.add kwd_table s (Kwd s)) keywords;
+  let ident_or_keyword id =
+    try Hashtbl.find kwd_table id with
+      Not_found -> Ident id
+  and keyword_or_error c =
+    let s = String.make 1 c in
+    try Hashtbl.find kwd_table s with
+      Not_found -> raise (Stream.Error ("Illegal character " ^ s))
+  in
+  let rec next_token (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some (' ' | '\010' | '\013' | '\009' | '\026' | '\012') ->
+        Stream.junk strm__; next_token strm__
+    | Some ('A'..'Z' | 'a'..'z' | '_' | '\192'..'\255' as c) ->
+        Stream.junk strm__;
+        let s = strm__ in reset_buffer (); store c; ident s
+    | Some
+        ('!' | '%' | '&' | '$' | '#' | '+' | '/' | ':' | '<' | '=' | '>' |
+         '?' | '@' | '\\' | '~' | '^' | '|' | '*' as c) ->
+        Stream.junk strm__;
+        let s = strm__ in reset_buffer (); store c; ident2 s
+    | Some ('0'..'9' as c) ->
+        Stream.junk strm__;
+        let s = strm__ in reset_buffer (); store c; number s
+    | Some '\'' ->
+        Stream.junk strm__;
+        let c =
+          try char strm__ with
+            Stream.Failure -> raise (Stream.Error "")
+        in
+        begin match Stream.peek strm__ with
+          Some '\'' -> Stream.junk strm__; Some (Char c)
+        | _ -> raise (Stream.Error "")
+        end
+    | Some '\"' ->
+        Stream.junk strm__;
+        let s = strm__ in reset_buffer (); Some (String (string s))
+    | Some '-' -> Stream.junk strm__; neg_number strm__
+    | Some '(' -> Stream.junk strm__; maybe_comment strm__
+    | Some c -> Stream.junk strm__; Some (keyword_or_error c)
+    | _ -> None
+  and ident (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some
+        ('A'..'Z' | 'a'..'z' | '\192'..'\255' | '0'..'9' | '_' | '\'' as c) ->
+        Stream.junk strm__; let s = strm__ in store c; ident s
+    | _ -> Some (ident_or_keyword (get_string ()))
+  and ident2 (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some
+        ('!' | '%' | '&' | '$' | '#' | '+' | '-' | '/' | ':' | '<' | '=' |
+         '>' | '?' | '@' | '\\' | '~' | '^' | '|' | '*' as c) ->
+        Stream.junk strm__; let s = strm__ in store c; ident2 s
+    | _ -> Some (ident_or_keyword (get_string ()))
+  and neg_number (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some ('0'..'9' as c) ->
+        Stream.junk strm__;
+        let s = strm__ in reset_buffer (); store '-'; store c; number s
+    | _ -> let s = strm__ in reset_buffer (); store '-'; ident2 s
+  and number (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some ('0'..'9' as c) ->
+        Stream.junk strm__; let s = strm__ in store c; number s
+    | Some '.' ->
+        Stream.junk strm__; let s = strm__ in store '.'; decimal_part s
+    | Some ('e' | 'E') ->
+        Stream.junk strm__; let s = strm__ in store 'E'; exponent_part s
+    | _ -> Some (Int (int_of_string (get_string ())))
+  and decimal_part (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some ('0'..'9' as c) ->
+        Stream.junk strm__; let s = strm__ in store c; decimal_part s
+    | Some ('e' | 'E') ->
+        Stream.junk strm__; let s = strm__ in store 'E'; exponent_part s
+    | _ -> Some (Float (float_of_string (get_string ())))
+  and exponent_part (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some ('+' | '-' as c) ->
+        Stream.junk strm__; let s = strm__ in store c; end_exponent_part s
+    | _ -> end_exponent_part strm__
+  and end_exponent_part (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some ('0'..'9' as c) ->
+        Stream.junk strm__; let s = strm__ in store c; end_exponent_part s
+    | _ -> Some (Float (float_of_string (get_string ())))
+  and string (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some '\"' -> Stream.junk strm__; get_string ()
+    | Some '\\' ->
+        Stream.junk strm__;
+        let c =
+          try escape strm__ with
+            Stream.Failure -> raise (Stream.Error "")
+        in
+        let s = strm__ in store c; string s
+    | Some c -> Stream.junk strm__; let s = strm__ in store c; string s
+    | _ -> raise Stream.Failure
+  and char (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some '\\' ->
+        Stream.junk strm__;
+        begin try escape strm__ with
+          Stream.Failure -> raise (Stream.Error "")
+        end
+    | Some c -> Stream.junk strm__; c
+    | _ -> raise Stream.Failure
+  and escape (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some 'n' -> Stream.junk strm__; '\n'
+    | Some 'r' -> Stream.junk strm__; '\r'
+    | Some 't' -> Stream.junk strm__; '\t'
+    | Some ('0'..'9' as c1) ->
+        Stream.junk strm__;
+        begin match Stream.peek strm__ with
+          Some ('0'..'9' as c2) ->
+            Stream.junk strm__;
+            begin match Stream.peek strm__ with
+              Some ('0'..'9' as c3) ->
+                Stream.junk strm__;
+                Char.chr
+                  ((Char.code c1 - 48) * 100 + (Char.code c2 - 48) * 10 +
+                     (Char.code c3 - 48))
+            | _ -> raise (Stream.Error "")
+            end
+        | _ -> raise (Stream.Error "")
+        end
+    | Some c -> Stream.junk strm__; c
+    | _ -> raise Stream.Failure
+  and maybe_comment (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some '*' ->
+        Stream.junk strm__; let s = strm__ in comment s; next_token s
+    | _ -> Some (keyword_or_error '(')
+  and comment (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some '(' -> Stream.junk strm__; maybe_nested_comment strm__
+    | Some '*' -> Stream.junk strm__; maybe_end_comment strm__
+    | Some _ -> Stream.junk strm__; comment strm__
+    | _ -> raise Stream.Failure
+  and maybe_nested_comment (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some '*' -> Stream.junk strm__; let s = strm__ in comment s; comment s
+    | Some _ -> Stream.junk strm__; comment strm__
+    | _ -> raise Stream.Failure
+  and maybe_end_comment (strm__ : _ Stream.t) =
+    match Stream.peek strm__ with
+      Some ')' -> Stream.junk strm__; ()
+    | Some '*' -> Stream.junk strm__; maybe_end_comment strm__
+    | Some _ -> Stream.junk strm__; comment strm__
+    | _ -> raise Stream.Failure
+  in
+  fun input -> Stream.from (fun _count -> next_token input)
+end
+
 open Netplex_types
 open Genlex
 open Printf
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netplex/netplex_kit.ml ocamlnet-4.1.9.patched/src/netplex/netplex_kit.ml
--- src/netplex/netplex_kit.ml	2021-03-24 16:20:15
+++ src/netplex/netplex_kit.ml	2026-05-29 06:31:44
@@ -89,7 +89,7 @@
 
 module PTYPE = struct
   type t = parallelization_type
-  let compare (x:t) (y:t) = Pervasives.compare x y
+  let compare (x:t) (y:t) = compare x y
 end
 
 module PSet = Set.Make(PTYPE)
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netplex/netplex_workload.ml ocamlnet-4.1.9.patched/src/netplex/netplex_workload.ml
--- src/netplex/netplex_workload.ml	2021-03-24 16:20:15
+++ src/netplex/netplex_workload.ml	2026-05-29 06:31:44
@@ -119,7 +119,7 @@
 
 module ContId = struct
   type t = container_id
-  let (compare : t -> t -> int) = Pervasives.compare
+  let (compare : t -> t -> int) = compare
 end
 
 
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netshm/META.in ocamlnet-4.1.9.patched/src/netshm/META.in
--- src/netshm/META.in	2021-03-24 16:20:14
+++ src/netshm/META.in	2026-05-29 06:31:44
@@ -1,6 +1,6 @@
 version = "@VERSION@"
 description = "Ocamlnet - Shared memory"
-requires = "unix netsys bigarray"
+requires = "unix netsys"
 archive(byte) = "netshm.cma"
 archive(native) = "netshm.cmxa"
 archive(native,gprof) = "netshm.p.cmxa"
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netshm/netshm.ml ocamlnet-4.1.9.patched/src/netshm/netshm.ml
--- src/netshm/netshm.ml	2021-03-24 16:20:14
+++ src/netshm/netshm.ml	2026-05-29 06:31:44
@@ -133,7 +133,7 @@
 
 module Int = struct
   type t = int
-  let compare = (Pervasives.compare : int -> int -> int)
+  let compare = (compare : int -> int -> int)
 end
 
 module IntMap = Map.Make(Int)
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netstring/Makefile ocamlnet-4.1.9.patched/src/netstring/Makefile
--- src/netstring/Makefile	2021-03-24 16:20:13
+++ src/netstring/Makefile	2026-05-29 06:31:44
@@ -3,7 +3,7 @@
 include $(TOP_DIR)/Makefile.conf
 
 OBJECTS  = netconst.cmo netstring_str.cmo netbuffer.cmo netunichar.cmo \
-	   netaux.cmo netstring_tstring.cmo \
+	   netaux.cmo netstring_tstring.cmo netstring_stream.cmo \
            netchannels.cmo netchannels_crypto.cmo netsockaddr.cmo \
 	   netdb.cmo netmappings_asn1.cmo netmappings.cmo netconversion.cmo \
            netulex.cmo netencoding.cmo netstream.cmo netdate.cmo \
@@ -28,7 +28,7 @@
 
 PKGNAME  = netstring
 
-REQUIRES += $(REGEXP_PROVIDER_MAKE) bigarray
+REQUIRES += $(REGEXP_PROVIDER_MAKE)
 INCLUDES += $(INC_NETSYS)
 INCLUDES += -I ../netstring-pcre
 
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netstring/netaccel_c.c ocamlnet-4.1.9.patched/src/netstring/netaccel_c.c
--- src/netstring/netaccel_c.c	2021-03-24 16:20:13
+++ src/netstring/netaccel_c.c	2026-05-29 06:31:44
@@ -25,7 +25,7 @@
 	srcpos_c+len_c > Wosize_val(src) ||
 	destpos_c < 0 ||
 	destpos_c+len_c > Wosize_val(dest))
-	invalid_argument("Netaccel.int_blit");
+	caml_invalid_argument("Netaccel.int_blit");
     
     if (src != dest || destpos_c <= srcpos_c) {
 	for (i=0; i<len_c; i++) {
@@ -59,7 +59,7 @@
 	srcpos_c+len_c > Wosize_val(src) ||
 	destpos_c < 0 ||
 	destpos_c+len_c > Wosize_val(dest))
-	invalid_argument("Netaccel.int_series");
+	caml_invalid_argument("Netaccel.int_series");
 
     s = n_c;
     for (i=0; i<len_c; i++) {
@@ -99,9 +99,9 @@
     slice_char_len = Wosize_val(slice_char);
 
     if (slice_char_len != Wosize_val(slice_blen)) 
-	invalid_argument("Netaccel.read_iso88591");
-    if (p_in_c < 0 || l_in_c < 0 || p_in_c + l_in_c > string_length(s_in)) 
-	invalid_argument("Netaccel.read_iso88591");
+	caml_invalid_argument("Netaccel.read_iso88591");
+    if (p_in_c < 0 || l_in_c < 0 || p_in_c + l_in_c > caml_string_length(s_in)) 
+	caml_invalid_argument("Netaccel.read_iso88591");
 
     m = l_in_c;
     if (slice_char_len < m) m = slice_char_len;
@@ -110,12 +110,12 @@
 	ch = Byte_u(s_in, p_in_c+k);
 	if (ch > maxcode_c) {
 	    Field(slice_char, k) = Val_long(-1);
-	    r = alloc_tuple(3);
+	    r = caml_alloc_tuple(3);
 	    Store_field(r, 0, Val_long(k));
 	    Store_field(r, 1, Val_long(k));
 	    Store_field(r, 2, enc);
-	    raise_with_arg(*caml_named_value("Netconversion.Malformed_code_read"),
-			   r);
+	    caml_raise_with_arg(*caml_named_value("Netconversion.Malformed_code_read"),
+                                r);
 	};
 	Field(slice_char, k) = Val_int((signed int) ch);
     };
@@ -124,7 +124,7 @@
 	Field(slice_char, m) = Val_long(-1);
     };
 
-    r = alloc_tuple(3);
+    r = caml_alloc_tuple(3);
     Store_field(r, 0, Val_long(m));
     Store_field(r, 1, Val_long(m));
     Store_field(r, 2, enc);
@@ -164,9 +164,9 @@
     slice_char_len = Wosize_val(slice_char);
 
     if (slice_char_len != Wosize_val(slice_blen)) 
-	invalid_argument("Netaccel.read_utf8");
-    if (p_in_c < 0 || l_in_c < 0 || p_in_c + l_in_c > string_length(s_in)) 
-	invalid_argument("Netaccel.read_utf8");
+	caml_invalid_argument("Netaccel.read_utf8");
+    if (p_in_c < 0 || l_in_c < 0 || p_in_c + l_in_c > caml_string_length(s_in)) 
+	caml_invalid_argument("Netaccel.read_utf8");
 
     p = p_in_c;
     p_max = p_in_c + l_in_c;
@@ -249,21 +249,21 @@
 	Field(slice_char, n_ret) = Val_long(-1);
     }
 
-    r = alloc_tuple(3);
+    r = caml_alloc_tuple(3);
     Store_field(r, 0, Val_long(n_ret));
     Store_field(r, 1, Val_long(p-p_in_c));
-    Store_field(r, 2, hash_variant("Enc_utf8"));
+    Store_field(r, 2, caml_hash_variant("Enc_utf8"));
 
     CAMLreturn(r);
 
  malformed_code:
     Field(slice_char, n) = Val_long(-1);
-    r = alloc_tuple(3);
+    r = caml_alloc_tuple(3);
     Store_field(r, 0, Val_long(n));
     Store_field(r, 1, Val_long(p-p_in_c));
-    Store_field(r, 2, hash_variant("Enc_utf8"));
-    raise_with_arg(*caml_named_value("Netconversion.Malformed_code_read"),
-		   r);
+    Store_field(r, 2, caml_hash_variant("Enc_utf8"));
+    caml_raise_with_arg(*caml_named_value("Netconversion.Malformed_code_read"),
+                        r);
 
     /* Cannot reach this point! */
     CAMLreturn(Val_unit);
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netstring/netchannels.ml ocamlnet-4.1.9.patched/src/netstring/netchannels.ml
--- src/netstring/netchannels.ml	2021-03-24 16:20:13
+++ src/netstring/netchannels.ml	2026-05-29 06:31:44
@@ -213,45 +213,45 @@
     if closed then self # complain_closed();
     try
       if len=0 then raise Sys_blocked_io;
-      let n = Pervasives.input ch buf pos len in
+      let n = input ch buf pos len in
       if n=0 then raise End_of_file else n
     with
 	Sys_blocked_io -> 0
 
   method really_input buf pos len = 
     if closed then self # complain_closed();
-    Pervasives.really_input ch buf pos len 
+    really_input ch buf pos len
 
   method really_input_string len = 
     if closed then self # complain_closed();
     #ifdef HAVE_BYTES
-      Pervasives.really_input_string ch len 
+      really_input_string ch len
     #else
       let buf = String.create len in
-      Pervasives.really_input ch buf 0 len;
+      really_input ch buf 0 len;
       buf
     #endif
 
   method input_char () =
     if closed then self # complain_closed();
-    Pervasives.input_char ch 
+    input_char ch
 
   method input_line () =
     if closed then self # complain_closed();
-    Pervasives.input_line ch 
+    input_line ch
 
   method input_byte () =
     if closed then self # complain_closed();
-    Pervasives.input_byte ch 
+    input_byte ch
 
   method close_in () =
     if not closed then (
-      Pervasives.close_in ch; closed <- true; onclose()
+      close_in ch; closed <- true; onclose()
     )
 
   method pos_in =
     if closed then self # complain_closed();
-    Pervasives.pos_in ch 
+    pos_in ch
 end
 ;;
 
@@ -999,17 +999,17 @@
 
   method output buf pos len =
     if closed then self # complain_closed();
-    (* Pervasives.output does not support non-blocking I/O directly.
+    (* output does not support non-blocking I/O directly.
      * Work around it:
      *)
-    let p0 = Pervasives.pos_out ch in
+    let p0 = pos_out ch in
     try 
-      Pervasives.output ch buf pos len;
+      output ch buf pos len;
       errflag := false;
       len
     with
       | Sys_blocked_io ->
-	  let p1 = Pervasives.pos_out ch in
+	  let p1 = pos_out ch in
 	  errflag := false;
 	  p1 - p0
       | error ->
@@ -1018,35 +1018,35 @@
 
   method really_output buf pos len =
     if closed then self # complain_closed();
-    monitored (Pervasives.output ch buf pos) len
+    monitored (output ch buf pos) len
 
   method really_output_string buf pos len =
     if closed then self # complain_closed();
     #ifdef HAVE_BYTES
-      monitored (Pervasives.output_substring ch buf pos) len
+      monitored (output_substring ch buf pos) len
     #else
-      monitored (Pervasives.output ch buf pos) len
+      monitored (output ch buf pos) len
     #endif
 
   method output_char c =
     if closed then self # complain_closed();
-    monitored (Pervasives.output_char ch) c
+    monitored (output_char ch) c
 
   method output_string s =
     if closed then self # complain_closed();
-    monitored (Pervasives.output_string ch) s
+    monitored (output_string ch) s
 
   method output_bytes s =
     if closed then self # complain_closed();
     #ifdef HAVE_BYTES
-      monitored (Pervasives.output_bytes ch) s
+      monitored (output_bytes ch) s
     #else
-      monitored (Pervasives.output_string ch) s
+      monitored (output_string ch) s
     #endif
 
   method output_byte b =
     if closed then self # complain_closed();
-    monitored (Pervasives.output_byte ch) b
+    monitored (output_byte ch) b
 
   method output_buffer b =
     if closed then self # complain_closed();
@@ -1061,7 +1061,7 @@
 
   method flush() =
     if closed then self # complain_closed();
-    monitored Pervasives.flush ch
+    monitored flush ch
 
   method close_out() =
     if not closed then (
@@ -1071,9 +1071,9 @@
 	     exception handler
 	   *)
 	  if !errflag then
-	    Pervasives.close_out_noerr ch
+	    close_out_noerr ch
 	  else
-	    Pervasives.close_out ch; 
+	    close_out ch; 
 	  closed <- true; 
 	with
 	  | error ->
@@ -1082,7 +1082,7 @@
 		"Netchannels.output_channel: \
                    Suppressed error in close_out: %s - backtrace: %s"
 		(Netexn.to_string error) bt;
-	      Pervasives.close_out_noerr ch;
+	      close_out_noerr ch;
 	      closed <- true; 
       );
       onclose()
@@ -1090,7 +1090,7 @@
 
   method pos_out = 
     if closed then self # complain_closed();
-    Pervasives.pos_out ch
+    pos_out ch
 
 end
 ;;
@@ -1844,7 +1844,7 @@
                   Suppressed error in close_out: %s - backtrace: %s"
 		(Netexn.to_string error) bt;
       );
-      Pervasives.close_in transch_in;
+      close_in transch_in;
       trans # close_out();      (* closes transch_out *)
       out # close_out();
       closed := true
@@ -1859,7 +1859,7 @@
     need_clear <- true;
     let len = trans # pos_out in
     trans # flush();
-    Pervasives.seek_in transch_in 0;
+    seek_in transch_in 0;
     let trans' = new input_channel transch_in in
     ( try 
         out # output_channel ~len trans';
@@ -1876,7 +1876,7 @@
   method private clear() =
     (* delete the contents of the file *)
     (* First empty the file and reset the output channel: *)
-    Pervasives.seek_out transch_out 0;
+    seek_out transch_out 0;
     Unix.ftruncate (Unix.descr_of_out_channel transch_out) 0;
     (* Renew the input channel. We create a new channel to avoid problems
      * with the internal buffer of the channel.
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netstring/netdate.ml ocamlnet-4.1.9.patched/src/netstring/netdate.ml
--- src/netstring/netdate.ml	2021-03-24 16:20:13
+++ src/netstring/netdate.ml	2026-05-29 06:31:44
@@ -5,6 +5,7 @@
 
 (* Thanks to Nicolas George for contributing the parsing and format code *)
 
+module Stream = Netstring_stream
 open Printf
 
 (* Calculate local zone offset in minutes *)
@@ -1035,11 +1036,11 @@
   format ~fmt (create ?localzone ?zone ?nanos t)
 
 let mk_mail_date ?localzone ?zone t =
-  format "%a, %d %b %Y %H:%M:%S %z" (create ?localzone ?zone t)
+  format ~fmt:"%a, %d %b %Y %H:%M:%S %z" (create ?localzone ?zone t)
 ;;
 
 let mk_usenet_date ?localzone ?zone t =
-  format "%A, %d-%b-%y %H:%M:%S %z" (create ?localzone ?zone t)
+  format ~fmt:"%A, %d-%b-%y %H:%M:%S %z" (create ?localzone ?zone t)
 ;;
 
 let mk_internet_date ?localzone ?zone ?(digits=0) t =
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netstring/nethtml.ml ocamlnet-4.1.9.patched/src/netstring/nethtml.ml
--- src/netstring/nethtml.ml	2021-03-24 16:20:13
+++ src/netstring/nethtml.ml	2026-05-29 06:31:44
@@ -283,7 +283,7 @@
 
 module S = struct
   type t = string
-  let compare = (Pervasives.compare : string -> string -> int)
+  let compare = (compare : string -> string -> int)
 end
 
 module Strset = Set.Make(S);;
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netstring/nethttp.ml ocamlnet-4.1.9.patched/src/netstring/nethttp.ml
--- src/netstring/nethttp.ml	2021-03-24 16:20:13
+++ src/netstring/nethttp.ml	2026-05-29 06:31:44
@@ -3,6 +3,8 @@
  * Nethttp: Basic definitions for the HTTP protocol
  *)
 
+module Stream = Netstring_stream
+
 type protocol_version = 
     int * int
 type protocol_attribute =
@@ -1009,7 +1011,7 @@
       snd
       (List.stable_sort
 	 (fun (q1, tok_param1) (q2, tok_param2) ->
-	    Pervasives.compare q2 q1)
+           compare q2 q1)
 	 (List.filter
 	    (fun (q, tok_param) ->
 	       q > 0.0)
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netstring/netmime.ml ocamlnet-4.1.9.patched/src/netstring/netmime.ml
--- src/netstring/netmime.ml	2021-03-24 16:20:13
+++ src/netstring/netmime.ml	2026-05-29 06:31:44
@@ -71,7 +71,7 @@
 end = struct
   type t = string
   let compare (a_ci:t) (b_ci:t) =
-    Pervasives.compare a_ci b_ci
+    compare a_ci b_ci
   let make s = STRING_LOWERCASE s
 end
 
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netstring/netmime_string.ml ocamlnet-4.1.9.patched/src/netstring/netmime_string.ml
--- src/netstring/netmime_string.ml	2021-03-24 16:20:13
+++ src/netstring/netmime_string.ml	2026-05-29 06:31:44
@@ -979,7 +979,7 @@
       | _, t ->
 	  t :: collect scn
   in
-  let scn = create_mime_scanner specials options s in
+  let scn = create_mime_scanner ~specials ~scan_options:options s in
   collect scn
 ;;
 
@@ -995,7 +995,7 @@
 let scan_encoded_text_value s =
   let specials = [ ' '; '\t'; '\r'; '\n'; '('; '['; '"' ] in
   let options =  [ Recognize_encoded_words ] in
-  let scn = create_mime_scanner specials options s in
+  let scn = create_mime_scanner ~specials ~scan_options:options s in
   
   let rec collect () =
     match scan_token scn with
@@ -1955,7 +1955,7 @@
   
 
 let scan_multipart_body_and_decode s ~start_pos:i0 ~end_pos:i1 ~boundary =
-  let parts = scan_multipart_body s i0 i1 boundary in
+  let parts = scan_multipart_body s ~start_pos:i0 ~end_pos:i1 ~boundary in
   List.map
     (fun (params, value) ->
        let encoding =
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netstring/netstring_stream.ml ocamlnet-4.1.9.patched/src/netstring/netstring_stream.ml
--- src/netstring/netstring_stream.ml	1970-01-01 01:00:00
+++ src/netstring/netstring_stream.ml	2026-05-29 06:31:44
@@ -0,0 +1,180 @@
+(* The Stream module from latest OCaml-4. It is no longer available in
+     OCaml-5.
+ *)
+type 'a t = 'a cell option
+ and 'a cell = { mutable count : int; mutable data : 'a data }
+ and 'a data =
+   Sempty
+ | Scons of 'a * 'a data
+ | Sapp of 'a data * 'a data
+ | Slazy of 'a data Lazy.t
+ | Sgen of 'a gen
+ | Sbuffio : buffio -> char data
+ and 'a gen = { mutable curr : 'a option option; func : int -> 'a option }
+ and buffio =
+   { ic : in_channel; buff : bytes; mutable len : int; mutable ind : int }
+
+exception Failure
+exception Error of string
+
+let count = function
+  | None -> 0
+  | Some { count } -> count
+let data = function
+  | None -> Sempty
+  | Some { data } -> data
+
+let fill_buff b =
+  b.len <- input b.ic b.buff 0 (Bytes.length b.buff); b.ind <- 0
+
+let rec get_data : type v. int -> v data -> v data = fun count d -> match d with
+   (* Returns either Sempty or Scons(a, _) even when d is a generator
+      or a buffer. In those cases, the item a is seen as extracted from
+   the generator/buffer.
+   The count parameter is used for calling `Sgen-functions'.  *)
+   Sempty | Scons (_, _) -> d
+ | Sapp (d1, d2) ->
+     begin match get_data count d1 with
+       Scons (a, d11) -> Scons (a, Sapp (d11, d2))
+     | Sempty -> get_data count d2
+     | _ -> assert false
+     end
+ | Sgen {curr = Some None} -> Sempty
+ | Sgen ({curr = Some(Some a)} as g) ->
+     g.curr <- None; Scons(a, d)
+ | Sgen g ->
+     begin match g.func count with
+       None -> g.curr <- Some(None); Sempty
+     | Some a -> Scons(a, d)
+         (* Warning: anyone using g thinks that an item has been read *)
+     end
+ | Sbuffio b ->
+     if b.ind >= b.len then fill_buff b;
+     if b.len == 0 then Sempty else
+       let r = Bytes.unsafe_get b.buff b.ind in
+       (* Warning: anyone using g thinks that an item has been read *)
+       b.ind <- succ b.ind; Scons(r, d)
+ | Slazy f -> get_data count (Lazy.force f)
+
+
+let rec peek_data : type v. v cell -> v option = fun s ->
+ (* consult the first item of s *)
+ match s.data with
+   Sempty -> None
+ | Scons (a, _) -> Some a
+ | Sapp (_, _) ->
+     begin match get_data s.count s.data with
+       Scons(a, _) as d -> s.data <- d; Some a
+     | Sempty -> None
+     | _ -> assert false
+     end
+ | Slazy f -> s.data <- (Lazy.force f); peek_data s
+ | Sgen {curr = Some a} -> a
+ | Sgen g -> let x = g.func s.count in g.curr <- Some x; x
+ | Sbuffio b ->
+     if b.ind >= b.len then fill_buff b;
+     if b.len == 0 then begin s.data <- Sempty; None end
+     else Some (Bytes.unsafe_get b.buff b.ind)
+
+
+let peek = function
+  | None -> None
+  | Some s -> peek_data s
+
+
+let rec junk_data : type v. v cell -> unit = fun s ->
+  match s.data with
+    Scons (_, d) -> s.count <- (succ s.count); s.data <- d
+  | Sgen ({curr = Some _} as g) -> s.count <- (succ s.count); g.curr <- None
+  | Sbuffio b ->
+      if b.ind >= b.len then fill_buff b;
+      if b.len == 0 then s.data <- Sempty
+      else (s.count <- (succ s.count); b.ind <- succ b.ind)
+  | _ ->
+      match peek_data s with
+        None -> ()
+      | Some _ -> junk_data s
+
+
+let junk = function
+  | None -> ()
+  | Some data -> junk_data data
+
+let rec nget_data n s =
+  if n <= 0 then [], s.data, 0
+  else
+    match peek_data s with
+      Some a ->
+        junk_data s;
+        let (al, d, k) = nget_data (pred n) s in a :: al, Scons (a, d), succ k
+    | None -> [], s.data, 0
+
+
+let npeek_data n s =
+  let (al, d, len) = nget_data n s in
+  s.count <- (s.count - len);
+  s.data <- d;
+  al
+
+
+let npeek n = function
+  | None -> []
+  | Some d -> npeek_data n d
+
+let next s =
+  match peek s with
+    Some a -> junk s; a
+  | None -> raise Failure
+
+
+let empty s =
+  match peek s with
+    Some _ -> raise Failure
+  | None -> ()
+
+
+let iter f strm =
+  let rec do_rec () =
+    match peek strm with
+      Some a -> junk strm; ignore(f a); do_rec ()
+    | None -> ()
+  in
+  do_rec ()
+
+
+(* Stream building functions *)
+
+let from f = Some {count = 0; data = Sgen {curr = None; func = f}}
+
+let of_list l =
+  Some {count = 0; data = List.fold_right (fun x l -> Scons (x, l)) l Sempty}
+
+
+let of_string s =
+  let count = ref 0 in
+  from (fun _ ->
+    (* We cannot use the index passed by the [from] function directly
+       because it returns the current stream count, with absolutely no
+       guarantee that it will start from 0. For example, in the case
+       of [Stream.icons 'c' (Stream.from_string "ab")], the first
+       access to the string will be made with count [1] already.
+    *)
+    let c = !count in
+    if c < String.length s
+    then (incr count; Some s.[c])
+    else None)
+
+
+let of_bytes s =
+  let count = ref 0 in
+  from (fun _ ->
+    let c = !count in
+    if c < Bytes.length s
+    then (incr count; Some (Bytes.get s c))
+    else None)
+
+
+let of_channel ic =
+  Some {count = 0;
+        data = Sbuffio {ic = ic; buff = Bytes.create 4096; len = 0; ind = 0}}
+
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/META.in ocamlnet-4.1.9.patched/src/netsys/META.in
--- src/netsys/META.in	2021-03-24 16:20:14
+++ src/netsys/META.in	2026-05-29 06:31:44
@@ -1,5 +1,5 @@
 description = "Ocamlnet - OS-specific functions"
-requires = "bytes,unix,bigarray"
+requires = "bytes,unix"
 version = "@VERSION@"
 archive(byte) = "netsys_oothr.cma netsys.cma"
 archive(native) = "netsys_oothr.cmxa netsys.cmxa"
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netlog.ml ocamlnet-4.1.9.patched/src/netsys/netlog.ml
--- src/netsys/netlog.ml	2021-03-24 16:20:14
+++ src/netsys/netlog.ml	2026-05-29 06:31:44
@@ -129,7 +129,7 @@
     
 
 let current_logger =
-  ref(channel_logger Pervasives.stderr `Debug)
+  ref(channel_logger stderr `Debug)
 
 
 let log lev msg =
